; TTL "COLOR TABLE"
;
; create a color table on the screen
;
; History
;========
;
; 22.09.2000 W. Schwotzer

MMU	EQU	$FFE0
SCRNBAS EQU	$0000	; Screen base address
SCRNSIZ	EQU	$4000	; Screen size in byte
STACK	EQU	$F000	; Base addr of stack

	ORG	$C100

RESET	EQU	*
START	BRA	START1

PLANES	FCB	$0C
	FCB	$0D
	FCB	$0E
	FCB	$04
	FCB	$05
	FCB	$06
	FCB	$FF

START1	LDS	#STACK
	LDY	#PLANES
	LDA	#64
	PSHS	A
LOOP1	LDB	,S
	LSRB
	STB	,S
	LDB	,Y+
	CMPB	#$FF
	BEQ	FINISH

	LBSR	SWTCH
	LDX	#SCRNBAS
	CLRA
LOOP2	LDB	,S
LOOP3	STA	,X+
	DECB
	BNE 	LOOP3
	COMA
	CMPX	#SCRNSIZ+SCRNBAS
	BNE	LOOP2
	BRA	LOOP1
	
FINISH	PULS	A
	LBSR	SWTCHB
END9	BRA	END9	; endless loop

SWTCH	PSHS	B
	TFR	B,A
	STD	MMU
	STD	MMU+2
	PULS	B, PC

SWTCHB	PSHS	B
	LDB	#$0F
	TFR	A, B
	STD	MMU
	STD	MMU+2
	PULS	B, PC

IRQ	RTI

	ORG	$FFF0

	FDB	0
	FDB	IRQ ; SWI3
	FDB	IRQ ; SWI2
	FDB	IRQ ; FIRQ
	FDB	IRQ ; IRQ
	FDB	IRQ ; SWI
	FDB	IRQ ; NMI
	FDB	RESET ; RESET

	END

